--AH:ScriptId=61c55ce4-483d-46d0-9d49-fd3417aa70c7;138

CREATE TABLE [BuildExecution_PlanActionLogEntries] (

	[Execution_Id] INT NOT NULL,
	[Original_Plan_Id] INT NOT NULL,
	[Original_Action_Sequence] INT NOT NULL,
	CONSTRAINT [FK__BuildExecution_PlanActionLogEntries__BuildExecution_PlanActions]
		FOREIGN KEY ([Execution_Id], [Original_Plan_Id], [Original_Action_Sequence])
		REFERENCES [BuildExecution_PlanActions] ([Execution_Id], [Original_Plan_Id], [Original_Action_Sequence]),
	[LogEntry_Sequence] INT NOT NULL
		CONSTRAINT [CK__BuildExecution_PlanActionLogEntries__LogEntry_Sequence_Domain]
		CHECK ([LogEntry_Sequence] > 0),

	CONSTRAINT [PK__BuildExecution_PlanActionLogEntries]
		PRIMARY KEY ([Execution_Id], [Original_Plan_Id], [Original_Action_Sequence], [LogEntry_Sequence]),

	[LogEntry_Level] INT NOT NULL
		CONSTRAINT [CK__BuildExecution_PlanActionLogEntries__LogEntry_Level]
		CHECK ([LogEntry_Level] >= 0),
	[LogEntry_Text] VARCHAR(MAX)

)
GO

INSERT INTO [BuildExecution_PlanActionLogEntries]
     ([Execution_Id]
      ,[Original_Plan_Id]
      ,[Original_Action_Sequence]
      ,[LogEntry_Sequence]
      ,[LogEntry_Level]
      ,[LogEntry_Text])
SELECT
      [Execution_Id]
      ,[Original_Plan_Id]
      ,[Original_Action_Sequence]
      ,1
      ,10
      ,[ExecutionLog_Text]
  FROM [BuildExecution_PlanActions]
GO

ALTER TABLE [BuildExecution_PlanActions]
 DROP COLUMN [ExecutionLog_Text]
GO