--AH:ScriptId=6d68369a-5a46-44b0-bc95-5c0396a457a6;290
exec sp_MsForEachTable 'ALTER TABLE ? NOCHECK CONSTRAINT ALL'

-- Applications
ALTER TABLE Applications DROP CONSTRAINT [UQ__Applications__Application_Name]
ALTER TABLE Applications ALTER COLUMN Application_Name VARCHAR(50)  NOT NULL 
ALTER TABLE Applications ADD CONSTRAINT [UQ__Applications__Application_Name] UNIQUE ([Application_Name])


-- BuildApprovals
ALTER TABLE BuildApprovals DROP CONSTRAINT [UQ__BuildApprovals]
ALTER TABLE BuildApprovals ALTER COLUMN Group_Name USERNAME  NULL
ALTER TABLE BuildApprovals ALTER COLUMN User_Name USERNAME  NOT NULL 
ALTER TABLE BuildApprovals ADD CONSTRAINT [UQ__BuildApprovals] UNIQUE([Application_Id], [Release_Number], [Build_Number], [Environment_Id], [User_Name], [Group_Name], [Approval_Description])

-- BuildArtifacts
ALTER TABLE BuildArtifacts DROP CONSTRAINT [PK__BuildArtifacts]
ALTER TABLE BuildArtifacts ALTER COLUMN Artifact_Name VARCHAR(40)  NOT NULL 
ALTER TABLE BuildArtifacts ADD CONSTRAINT [PK__BuildArtifacts] PRIMARY KEY ([Application_Id], [Release_Number], [Build_Number], [Artifact_Name])

--BuildPromotions
ALTER TABLE BuildPromotions ALTER COLUMN PromotedBy_Name USERNAME  NOT NULL 

--Deployables
ALTER TABLE Deployables DROP CONSTRAINT UQ__Deployables__ApplicationDeployables_Name
ALTER TABLE Deployables ALTER COLUMN Deployable_Name VARCHAR(50)  NOT NULL 
ALTER TABLE Deployables ADD CONSTRAINT [UQ__Deployables__ApplicationDeployables_Name] UNIQUE ([Application_Id], [Deployable_Name])

-- Environments
ALTER TABLE Environments DROP CONSTRAINT [UQ__Environments__Environment_Name]
ALTER TABLE Environments ALTER COLUMN Environment_Name VARCHAR(50)  NOT NULL 
ALTER TABLE Environments ADD CONSTRAINT [UQ__Environments__Environment_Name] UNIQUE([Environment_Name])

-- PromotionApprovalRequirements
ALTER TABLE PromotionApprovalRequirements ALTER COLUMN User_Name USERNAME  NOT NULL 

--Providers
ALTER TABLE Providers ALTER COLUMN Provider_Description VARCHAR(MAX)  NOT NULL 

--Releases
ALTER TABLE Releases DROP CONSTRAINT CK__Releases__ReleasesStatus_Name_Domain
ALTER TABLE Releases ALTER COLUMN Release_Name VARCHAR(50)  NULL
ALTER TABLE Releases ALTER COLUMN ReleaseStatus_Name VARCHAR(9)  NOT NULL 
ALTER TABLE Releases ADD CONSTRAINT [CK__Releases__ReleasesStatus_Name_Domain] CHECK ([ReleaseStatus_Name] IN ('Active', 'Cancelled', 'Deployed'))

--Servers
ALTER TABLE Servers DROP CONSTRAINT UQ__Servers__Server_Name
ALTER TABLE Servers ALTER COLUMN Agent_Url VARCHAR(255)  NULL
ALTER TABLE Servers ALTER COLUMN Server_Name VARCHAR(50)  NOT NULL 
ALTER TABLE Servers ADD CONSTRAINT [UQ__Servers__Server_Name] UNIQUE([Server_Name])

--Users
ALTER TABLE Users ALTER COLUMN Display_Name VARCHAR(100)  NOT NULL 
ALTER TABLE Users ALTER COLUMN Email_Address VARCHAR(250)  NULL

--Workflows
ALTER TABLE Workflows ALTER COLUMN Workflow_Name VARCHAR(20)  NOT NULL 

--------------------------

--BuildExecution_PlanActions
ALTER TABLE BuildExecution_PlanActions ALTER COLUMN ExecutionStatus_Name VARCHAR(10)  NOT NULL 

--BuildExecutions
ALTER TABLE BuildExecutions DROP CONSTRAINT [CK__BuildExecution_Plans__ExecutionStatus_Name_Domain]
ALTER TABLE BuildExecutions ALTER COLUMN ExecutionStatus_Name VARCHAR(10)  NOT NULL 
ALTER TABLE BuildExecutions ADD CONSTRAINT [CK__BuildExecution_Plans__ExecutionStatus_Name_Domain] CHECK  (([ExecutionStatus_Name]='Canceled' OR [ExecutionStatus_Name]='Failed' OR [ExecutionStatus_Name]='Succeeded' OR [ExecutionStatus_Name]='Executing' OR [ExecutionStatus_Name]='Pending'))

--Builds
ALTER TABLE Builds DROP CONSTRAINT [CK__BuildPromotions__Rejected_Validity]
ALTER TABLE Builds DROP CONSTRAINT [CK__Builds__Build_Status_Name_Domain]
ALTER TABLE Builds ALTER COLUMN BuildStatus_Name VARCHAR(8)  NOT NULL 
ALTER TABLE Builds ADD CONSTRAINT [CK__BuildPromotions__Rejected_Validity] CHECK (([BuildStatus_Name]='Rejected' AND [RejectedBy_User_Name] IS NOT NULL AND [Rejected_Date] IS NOT NULL OR [BuildStatus_Name]<>'Rejected' AND [RejectedBy_User_Name] IS NULL AND [Rejected_Date] IS NULL))
ALTER TABLE Builds ADD CONSTRAINT [CK__Builds__Build_Status_Name_Domain] CHECK  (([BuildStatus_Name]='Deployed' OR [BuildStatus_Name]='Rejected' OR [BuildStatus_Name]='Active'))

--PromotionApprovalRequirements
ALTER TABLE [PromotionApprovalRequirements]
 DROP CONSTRAINT [CK__PromotionApprovalRequirements__ApprovalType_Code_Domain]
ALTER TABLE [PromotionApprovalRequirements]
 DROP CONSTRAINT [CK__PromotionApprovalRequirements__RequiredInGroup_Count_Domain]
ALTER TABLE [PromotionApprovalRequirements]
 DROP CONSTRAINT [DF__PromotionApprovalRequirements__ApprovalType_Code]
ALTER TABLE PromotionApprovalRequirements ALTER COLUMN ApprovalType_Code CHAR(1)  NOT NULL 
ALTER TABLE [PromotionApprovalRequirements]
  ADD CONSTRAINT [CK__PromotionApprovalRequirements__ApprovalType_Code_Domain]
			CHECK ([ApprovalType_Code] IN ('G', 'U')),
		CONSTRAINT [CK__PromotionApprovalRequirements__RequiredInGroup_Count_Domain]
			CHECK ( ([ApprovalType_Code] = 'U' AND [RequiredInGroup_Count] IS NULL)
				OR ([ApprovalType_Code] = 'G' AND [RequiredInGroup_Count] IS NOT NULL AND [RequiredInGroup_Count] > 0) )
ALTER TABLE [PromotionApprovalRequirements] ADD  CONSTRAINT [DF__PromotionApprovalRequirements__ApprovalType_Code]  DEFAULT ('U') FOR [ApprovalType_Code]
				
--Providers
ALTER TABLE [Providers]  DROP CONSTRAINT [CK__Providers__ProviderType_Code_Domain] 
ALTER TABLE Providers ALTER COLUMN ProviderType_Code CHAR(1)  NOT NULL 
ALTER TABLE [Providers]  ADD  CONSTRAINT [CK__Providers__ProviderType_Code_Domain] CHECK  (([ProviderType_Code]='S' OR [ProviderType_Code]='I' OR [ProviderType_Code]='D' OR [ProviderType_Code]='B'))

exec sp_MsForEachTable 'ALTER TABLE ? CHECK CONSTRAINT ALL'