IF OBJECT_ID('[TR__DeployableDependencies__ValidateDeployableId]') IS NOT NULL DROP TRIGGER [TR__DeployableDependencies__ValidateDeployableId]
GO

CREATE TRIGGER [TR__DeployableDependencies__ValidateDeployableId] 
       ON [DeployableDependencies] FOR UPDATE, INSERT 
AS 
BEGIN
	IF EXISTS(SELECT *
				FROM [inserted] i
					 INNER JOIN [Deployables] D1 ON D1.[Deployable_Id] = i.[Deployable_Id]
					 INNER JOIN [Deployables] D2 ON D2.[Deployable_Id] = i.[DependsOn_Deployable_Id]
			   WHERE D1.[Application_Id] <> D2.[Application_Id])
		BEGIN
			RAISERROR('Cross-application deployables are not supported.', 16, 1)
			ROLLBACK
		END
END
GO