IF OBJECT_ID('[Packages_Extended]') IS NOT NULL DROP VIEW [Packages_Extended]
GO

CREATE VIEW [Packages_Extended] AS

SELECT P.*
	  ,[Pipeline_Name] = COALESCE(B.[Pipeline_Name], R.[Pipeline_Name])
	  ,R.[Release_Id]
	  ,R.[Release_Number]
	  ,R.[Release_Name]
	  ,R.[ReleaseTemplate_Name]
	  ,B.[BuildStatus_Name]
	  ,A.[Application_Id]
	  ,A.[Application_Name]
	

  FROM [Packages] P
		LEFT JOIN [Builds] B
				ON B.[Build_Id] = P.[Build_Id]
		 LEFT JOIN [Releases] R
				ON R.[Release_Id] = B.[Release_Id]
		 LEFT JOIN [Applications] A
				ON A.[Application_Id] = B.[Application_Id]

GO
