EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'Applications_FindDeployables',
    /* Internal_Indicator      */ 'N',
    /* ReturnType_Name         */ 'DataTable',
    /* DataTableNames_Csv      */ 'Deployables_Extended',
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Searches for deployables in the system.'
GO

IF OBJECT_ID('[Applications_FindDeployables]') IS NOT NULL DROP PROCEDURE [Applications_FindDeployables]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [Applications_FindDeployables]
(
	@SearchTerm_Text VARCHAR(50),
	@Max_Count INT
)
AS
BEGIN

	SET NOCOUNT ON

	SET @SearchTerm_Text = NULLIF(@SearchTerm_Text, '')
	IF @SearchTerm_Text IS NOT NULL
	BEGIN
		SET @SearchTerm_Text = REPLACE(@SearchTerm_Text, '_', '\_')
		SET @SearchTerm_Text = REPLACE(@SearchTerm_Text, '%', '\%')
		SET @SearchTerm_Text = REPLACE(@SearchTerm_Text, '[', '\[')
		SET @SearchTerm_Text = @SearchTerm_Text + '%'
	END

	IF @Max_Count IS NOT NULL
		SET ROWCOUNT @Max_Count

	SELECT *
	  FROM [Deployables_Extended]
     WHERE @SearchTerm_Text IS NULL
	    OR [Deployable_Name] LIKE @SearchTerm_Text ESCAPE '\'
		OR [Application_Name] LIKE @SearchTerm_Text ESCAPE '\'

END
GO

GRANT EXECUTE ON [Applications_FindDeployables] TO [BuildMasterUser_Role]
