EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'ConfigurationFiles_GetConfigurationFileInstances',
    /* Internal_Indicator      */ 'N',
    /* ReturnType_Name         */ 'DataTable',
    /* DataTableNames_Csv      */ 'ConfigurationFileInstances_Extended',
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Gets a list of all configuration file instances that match the specified criteria.'
GO


IF OBJECT_ID('[ConfigurationFiles_GetConfigurationFileInstances]') IS NOT NULL DROP PROCEDURE [ConfigurationFiles_GetConfigurationFileInstances]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [ConfigurationFiles_GetConfigurationFileInstances]
(
	@Application_Id INT = NULL,
	@Deployable_Id INT = NULL,
	@Active_Indicator YNINDICATOR = NULL
)
AS
BEGIN

	SET NOCOUNT ON

	SELECT CFI.*
	  FROM [ConfigurationFileInstances_Extended] CFI
		   LEFT JOIN [Environments] E
				 ON E.[Environment_Id] = CFI.[Environment_Id]
	 WHERE (@Application_Id IS NULL OR CFI.[Application_Id] = @Application_Id)
	   AND (@Deployable_Id IS NULL OR CFI.[Deployable_Id] = @Deployable_Id)
	   AND (@Active_Indicator IS NULL OR CFI.[Active_Indicator] = @Active_Indicator)
	ORDER BY E.[Display_Sequence], CFI.[Instance_Name]
END
GO

GRANT EXECUTE ON [ConfigurationFiles_GetConfigurationFileInstances] TO [BuildMasterUser_Role]
